#include <QtGui/QApplication>
#include "DfBrowser/dbrowser.h"
#include "DfBrowser/extras/orientation.h"

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QDir dir(QDir::homePath());
    if (a.arguments().count()>1){
        if (dir.exists(a.arguments().at(1)))
            dir.setPath(a.arguments().at(1));
    }
    DBrowser *window=new DBrowser(dir.path());
    window->fBrowser->setBasePath(QDir::homePath());

    //Orientation orientation;
    window->setAttribute(Orientation::setOrientation(Orientation::ScreenOrientationAuto));

    switch (Orientation::showMode()){
        case Orientation::ShowModeFullScreen: window->showFullScreen();break;
        case Orientation::ShowModeMaximized: window->showMaximized();break;
        case Orientation::ShowModeNormal: window->show();break;
        default: window->show();
    };

#if defined(Q_OS_SYMBIAN) || defined(Q_WS_MAEMO_5) || defined(QT_SIMULATOR) || defined(MEEGO_EDITION) || defined(UI_TABLET)
    qDebug("Esto es movil");
#endif

    return a.exec();
}
